//
//  mdlRepairType.swift
//
//
//  Created by Michiel Carman on 1/24/24.
//

import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlRepairType: Model, Content {
    static let schema = "repairType"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Field(key: "name") var name: String?
    @Field(key: "description") var description: String?
    @Field(key: "color") var color: String?
    
    @Children(for: \.$repairtype) var units: [mdlResponseType]
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil, name: String? = nil, description: String? = nil, color: String? = nil, createuserid: Int? = nil, updateuserid: Int? = nil) {
        self.id = id
        
        self.name = name
        self.description = description
        self.color = color
        
        
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlRepairType{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("repairType")
                .field("id", .int, .identifier(auto: true))
                .field("name", .string)
                .field("description", .string)
                .field("color", .string)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func revert(on database: Database) async throws {
            try await database.schema("repairType").delete()
        }
    }
    struct Seed: Migration{
        func prepare(on database: Database) -> EventLoopFuture<Void> {
            let mdls: [mdlRepairType] = [
                .init(id: 1, name: "None", description: nil, color: "#000000", createuserid: -1, updateuserid: -1),
                .init(id: 2, name: "Recommended", description: nil, color: "#FFCC00", createuserid: -1, updateuserid: -1),
                .init(id: 3, name: "Urgent", description: nil, color: "#FF0000", createuserid: -1, updateuserid: -1),
                .init(id: 4, name: "NA", description: nil, color: "#000000", createuserid: -1, updateuserid: -1)
            ]
            return mdls.map { mdl in
                    mdl.save(on: database)
                  }
                  .flatten(on: database.eventLoop)
        }
        
        func revert(on database: Database) -> EventLoopFuture<Void> {
            mdlRepairType.query(on: database).delete()
        }
        
        
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlRepairType>{
        
        let query = mdlRepairType.query(on: req.db)
            .with(\.$units)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}



